/*
 *		I M P R O C E S S . C
 *
 *	Part of the MDQS Imagen server process (imserver)
 *
 *	This is an ugly module for doing page counting for the various
 *	Imagen text languages (Rev 1.8 of Imagen Software).
 */
#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>		/* for use with ntohs() (byte swaping) */

impress (input, output)
register FILE	*input;
register FILE	*output;
{
	register int i;
	register int c;
	int	pagecnt = 0;
	char	buf[512];
	unsigned short uword;
	short	word;

	while ((c = getc(input)) != EOF) {
		putc(c, output);		
		switch (c) {
		case 219:		/* ENDPAGE */
			pagecnt++;
			break;

		case 255:		/* EOF */
			if (pagecnt == 0)
				pagecnt = 1;
			while ((c = getc(input)) != EOF)
				putc(c, output);
			break;

		/* One BYTE commands */
		case 128:		/* SP */
		case 129:		/* SP1 */
		case 131:		/* MPLUS */
		case 132:		/* MMINUS */
		case 197:		/* CRLF */
		case 211:		/* PUSH */
		case 212:		/* POP */
		case 213:		/* PAGE (obsolete) */
		case 240:		/* FORCE_GLY_DELETE */
			break;

		/* Two BYTE commands */
		case 205:		/* SET_HV_SYSTEM */
		case 206:		/* SET_ADV_DIRS */
		case 207:		/* SET_FAMILY */
		case 232:		/* SET_PEN */
		case 233:		/* FILL_PATH */
		case 234:		/* DRAW_PATH */
		case 236:		/* SET_MAGNIFICATION */
		case 243:		/* EXECUTE_MACRO */
			putc (getc(input), output);
			break;

		/* Three BYTE commands */
		case 130:		/* M (obsolete) */
		case 133:		/* MMOVE */
		case 134:		/* SMOVE */
		case 135:		/* SET_ABS_H */
		case 136:		/* SET_REL_H */
		case 137:		/* SET_ABS_V */
		case 138:		/* SET_REL_V */
		case 195:		/* SET_HPOS (obsolete) */
		case 196:		/* SET_VPOS (obsolete) */
		case 200:		/* DELG */
		case 208:		/* SET_IL */
		case 209:		/* SET_BOL */
		case 210:		/* SET_SP */
		case 214:		/* SET_PUSH_MASK */
		case 231:		/* SET_TEXTURE */
			putc (getc(input), output);
			putc (getc(input), output);
			break;

		/* Four BYTE commands */
		case 192:		/* SRULE (obsolete) */
			putc (getc(input), output);
			putc (getc(input), output);
			putc (getc(input), output);
			break;

		/* Seven BYTE commands */
		case 193:		/* BRULE */
			for (i = 0; i < 6; i++)
				putc (getc(input), output);
			break;

		/* Eleven BYTE commands */
		case 203:		/* MAKE_TEXTURE */
			for (i = 0; i < 10; i++)
				putc (getc(input), output);
			break;

		case 198:		/* SGLY (obsolete) */
			fread (buf, 3, 1, input);
			fwrite (buf, 3, 1, output);
			putc(c = getc(input), output);
			i = ((int)c+7)/8;
			putc(c = getc(input), output);
			putc(c = getc(input), output);
			i *= (int)c;
			while (i-- > 0)
				putc(getc(input), output);
			putc(c = getc(input), output);
			break;

		case 199:		/* BGLY */
			fread (buf, 4, 1, input);
			fwrite (buf, 4, 1, output);
			fread (&word, sizeof(word), 1, input);
			fwrite (&word, sizeof(word), 1, output);
			word = ntohs (word);
			i = (word+7)/8;
			fread (&word, sizeof(word), 1, input);
			fwrite (&word, sizeof(word), 1, output);
			fread (&word, sizeof(word), 1, input);
			fwrite (&word, sizeof(word), 1, output);
			word = ntohs (word);
			i *= word;
			fread (&word, sizeof(word), 1, input);
			fwrite (&word, sizeof(word), 1, output);
			while (i-- > 0)
				putc(getc(input), output);
			break;

		case 221:		/* CREATE_FAMILY_TABLE */
			putc(c = getc(input), output);
			uword = (unsigned short)c;
			while (uword-- > 0) {
				putc(c = getc(input), output);
				putc(c = getc(input), output);
				putc(c = getc(input), output);
				putc(c = getc(input), output);
			}
			break;

		case 222:		/* CREATE_MAP */
			putc(c = getc(input), output);
			uword = (unsigned short)c;
			while (uword-- > 0) {
				putc(c = getc(input), output);
				while ((c = getc(input)) != 0)
					putc(c, output);
				putc (c, output);
			}
			break;

		case 230:		/* CREATE_PATH */
			fread (&word, sizeof(word), 1, input);
			fwrite (&word, sizeof(word), 1, output);
			word = ntohs(word);
			while (word-- > 0) {
				putc(c = getc(input), output);
				putc(c = getc(input), output);
				putc(c = getc(input), output);
				putc(c = getc(input), output);
			}
			break;

		case 235:		/* BITMAP */
			putc(c = getc(input), output);
			putc(c = getc(input), output);
			uword = (unsigned short)c;
			putc(c = getc(input), output);
			uword *= (unsigned short)c;
			while (uword-- > 0) {
				for (i=128; i > 0; i--)
					putc(c = getc(input), output);
			}
			break;

		case 242:		/* DEFINE_MACRO */
			fread (&word, sizeof(word), 1, input);
			fwrite (&word, sizeof(word), 1, output);
			word = ntohs(word);
			while (word-- > 0)
				putc(getc(input), output);
			break;
		}
		if (ferror(output))
			return (pagecnt);
	}
	return (pagecnt);
}

tektronix(input, output)
register FILE	*input;
register FILE	*output;
{
	register char	c;
	register int	pagecnt = 1;

	while ((c = getc(input)) != EOF) {
		putc(c, output);
		if (c == 033) {
			putc(c = getc(input), output);
			if (c == '\f')
				pagecnt++;
		}
		if (ferror(output))
			return (pagecnt);
	}
	return (pagecnt);
}

printer(input, output)
register FILE	*input;
register FILE	*output;
{
	register char	c;
	register int linecnt = 0;
	int	pagecnt = 1;

	while ((c = getc(input)) != EOF) {
		putc(c, output);
		if (ferror(output))
			return (pagecnt);
		switch (c) {
		case '\f':
			pagecnt++;
			linecnt = 0;
			break;
		case '\n':
			if (++linecnt == 60) {
				linecnt = 0;
				pagecnt++;
			}
		}
	}
	return (pagecnt);
}

daisy(input, output)
register FILE	*input;
register FILE	*output;
{
	register char	c;
	register int hlinecnt = 0;
	int	pagecnt = 1;

	while ((c = getc(input)) != EOF) {
		putc(c, output);
		switch (c) {
		case '\f':
			pagecnt++;
			hlinecnt = 0;
			break;
		case '\n':
			hlinecnt += 2;
			if (hlinecnt >= 120) {
				hlinecnt = 0;
				pagecnt++;
			}
			break;
		case 033:
			putc(c = getc(input), output);
			switch (c) {
			case '\n':
				hlinecnt -= 2;
				break;
			case 'U':
				hlinecnt--;
				break;
			case 'D':
				if (++hlinecnt >= 120) {
					hlinecnt = 0;
					pagecnt++;
				}
				break;
			}
			if (hlinecnt < 0)
				hlinecnt = 0;
		}
		if (ferror(output))
			return (pagecnt);
	}
	return (pagecnt);
}
