#
/*
 *		M U L T I - D E V I C E   Q U E U E I N G   S Y S T E M
 *
 *				       L O G . C
 *
 *				Douglas P. Kingston III
 *
 *				    Revision History
 *				    ================
 */

#include <stdio.h>
#include "qconf.h"

#if BSD42 | BSD41c
#include <sys/types.h>
#include <sys/file.h>
#endif

#if SYS3
#include <fcntl.h>
#endif

extern char *Logfile;
extern FILE *fopen();
extern char *ctime();

static	FILE	*logfp = NULL;

loginit ()
{
	register int	fd;

	if (logfp != NULL)
		fclose (logfp);
#if V6 | V7 | BSD41 | BRLUNIX
	if ((fd = open (Logfile, 1)) < 0) {
#endif
#if SYS3 | BSD42 | BSD41c
	if ((fd = open (Logfile, O_WRONLY | O_APPEND)) < 0) {
#endif
		complain ("Unable to open logfile '%s'", Logfile);
		return (-1);
	}
	if ((logfp = fdopen(fd, "a")) == NULL)
		return (-1);
	return (0);
}

log (fmt, b, c, d, e)
char	*fmt, *b, *c, *d, *e;
{
	long	timenow;

	if (logfp == NULL)
		return;
	fseek (logfp, 0L, 2);
	time(&timenow);
	fprintf (logfp, "%19.19s ", ctime(&timenow));
	fprintf (logfp, fmt, b, c, d, e);
	fputc ('\n', logfp);
	fflush (logfp);
	return;
}
