/*
 *			N E T O P E N . C
 *
 *	Open a TCP/MDQS connection using Berkeley 4.2 style networking.
 *
 *	Doug Kingston, 6 Mar 83 at BRL.
 */
#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

extern int errno;
extern char *sys_errlist[];

FILE *
netopen (host, port)
char	*host;
int	port;
{
	register int skt;
	struct sockaddr_in addr;
	struct hostent *gethostbyname();
	struct hostent *hp;
	register int i;

	if ((hp = gethostbyname(host)) == NULL) {
		err ("MDQS NETSEND: Unknown host '%s'", host);
		return (NULL);
	}
	
	addr.sin_family = hp->h_addrtype;
	addr.sin_port = htons(port);

	bmove (hp->h_addr, &addr.sin_addr, hp->h_length);

	skt = socket( AF_INET, SOCK_STREAM, 0, 0 );
	if( skt < 0 ) {
		err ("MDQS NETSEND: Can't get socket (%s)", sys_errlist[errno]);
		return( NULL );
	}
#ifdef notdef
	if (setsockopt (skt, SOL_SOCKET, SO_DONTLINGER, 0, 0)) {
		err ("MDQS NETSEND: Can't set socket options (%s)", sys_errlist[errno]);
		close (skt);
		return( NULL );
	}
#endif notdef

	if( connect(skt, &addr, sizeof addr, 0) < 0 ) {
		close( skt );
#ifdef NOISY
		err ("MDQS NETSEND: Can't get connection (%s)", sys_errlist[errno]);
#endif
		return( NULL );
	}
	return (fdopen(skt, "r+"));
}

static
bmove (cp1, cp2, n)
char	*cp1, *cp2;
int	n;
{
	while (n--)
		*cp2++ = *cp1++;
}
